﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CollapseAllIssue
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        DataSet flexGridDefDataset = new DataSet();
        DataTable dt1 = new DataTable("dt1");
        DataTable dt2 = new DataTable("dt2");
        DataTable dt3 = new DataTable("dt3");
        private void ultraButton1_Click(object sender, EventArgs e)
        {
           
           
            
        }

        private void FillData()
        {
            dt1.Columns.Add("Id");
            dt1.Columns.Add("Name1");
            dt1.Columns.Add("Name2");
            dt1.Columns.Add("Name3");
            dt1.Columns.Add("Name4");
            flexGridDefDataset.Tables.Add(dt1);


            dt2.Columns.Add("Id");
            dt2.Columns.Add("Name1");
            dt2.Columns.Add("Name2");
            dt2.Columns.Add("Name3");
            dt2.Columns.Add("Name4");
            flexGridDefDataset.Tables.Add(dt2);

            dt3.Columns.Add("Id");
            dt3.Columns.Add("Name1");
            dt3.Columns.Add("Name2");
            dt3.Columns.Add("Name3");
            dt3.Columns.Add("Name4");
            flexGridDefDataset.Tables.Add(dt3);
            flexGridDefDataset.Relations.Add(new DataRelation("Rel1", flexGridDefDataset.Tables["dt1"].Columns["Id"],
            flexGridDefDataset.Tables["dt2"].Columns["Id"], false));

            flexGridDefDataset.Relations.Add(new DataRelation("Rel2", flexGridDefDataset.Tables["dt2"].Columns["Id"],
            flexGridDefDataset.Tables["dt3"].Columns["Id"], false));
           
     
            for (int i = 0; i <= 50; i++)
            {
                DataRow drDt1 = dt1.NewRow();
                drDt1["Id"] = i.ToString();
                drDt1["Name1"] = "Name1" + i.ToString();
                drDt1["Name2"] = "Name2" + i.ToString();
                drDt1["Name3"] = "Name3" + i.ToString();
                drDt1["Name4"] = "Name4" + i.ToString();
                dt1.Rows.Add(drDt1);
                for (int j = 0; j <= 50; j++)
                {
                    DataRow drDt2 = dt2.NewRow();
                    drDt2["Id"] = i.ToString();
                    drDt2["Name1"] = "Name1" + i.ToString();
                    drDt2["Name2"] = "Name2" + j.ToString();
                    drDt2["Name3"] = "Name3" + j.ToString();
                    drDt2["Name4"] = "Name4" + j.ToString();
                    dt2.Rows.Add(drDt2);
                }
                for (int k = 0; k <= 50; k++)
                {
                    DataRow drDt3 = dt3.NewRow();
                    drDt3["Id"] = i.ToString();
                    drDt3["Name1"] = "Name1" + k.ToString();
                    drDt3["Name2"] = "Name2" + k.ToString();
                    drDt3["Name3"] = "Name3" + k.ToString();
                    drDt3["Name4"] = "Name4" + k.ToString();
                    dt3.Rows.Add(drDt3);
                }

            }

            this.ultraGrid1.DataSource = flexGridDefDataset;
        }

        private void btnCollapseAl_Click(object sender, EventArgs e)
        {
            this.ultraGrid1.Rows.CollapseAll(true);
        }

        private void btnExpandAll_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Stopwatch sw = new System.Diagnostics.Stopwatch();
            sw.Start();
            this.ultraGrid1.Rows.ExpandAll(true);
            sw.Stop();
            System.Diagnostics.Debug.WriteLine(sw.ElapsedMilliseconds.ToString());
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            FillData();

        }
    }
}
